(herald (assembler loader))

(define (comfiler ln)
  (lambda (name)
    (comfile `(,ln ,name))))

(define (loader ln env)
  (lambda (name)
    (let ((filespec `(,ln ,name)))
      (*require filespec filespec env))))

(define tas-env (make-locale orbit-env 'tas-env))
(define tas-syntax-table (env-syntax-table tas-env))

(bind (((print-env-warnings?) '#f))
  ;; Shadow these because of weird bugs lurking in the system.
  ;; ORBIT-ENV defines VECTOR to be -7, not the regular procedure, and
  ;; I don't know why we have to redefine ORBIT-ENV here.  (LAP
  ;; evaluator?)
  (*define tas-env 'orbit-env tas-env)
  (*define tas-env 'vector vector))

(define tas-files
  '(
    as_open
    ib
    expand
    as_utils
    compile_fgs
    as_syntax
    fg
    as
    count
    mark
    mini
    bits
    listing
    lap
    as_file
    ))

(define (compile-tas)
  (walk (comfiler 'assembler) tas-files))

(define (load-tas)
  (walk (loader 'assembler tas-env) tas-files))

;;;; PowerPC

(define tas-ppc-env (make-locale tas-env 'tas-ppc-env))
(define tas-ppc-syntax-table (env-syntax-table tas-ppc-env))
(*define tas-env 'tas-ppc-env tas-ppc-env)

(define tas-ppc-early-files
  '(
    ppc_machine         ; machine & register set definition
    ppc_format          ; instruction formats
    ))

(define tas-ppc-files
  '(
    ppc_arith           ; integer arithmetic instructions
    ppc_branch          ; branch instructions
    ppc_flo             ; floating-point instructions
    ppc_mem             ; memory access instructions
    ppc_misc            ; miscellaneous instructions
    ppc_lap             ; LAP environment
    ))

(define (compile-ppc-tas)
  (let ((comfile (comfiler 'assembler)))
    (walk comfile tas-ppc-early-files)
    (walk (loader 'assembler tas-ppc-env) tas-ppc-early-files)
    (walk comfile tas-ppc-files)))

(define (load-ppc-tas)
  (let ((load (loader 'assembler tas-ppc-env)))
    (walk load tas-ppc-early-files)
    (walk load tas-ppc-files)))
